unit uForm;
{ This DataModule contains the class TWindow and its Procs}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  LangValue, VisualValue, ClassValue, ValueUtils, VarLangValue, LangProc, uConsole;

type
  TWindowData = class(TDataModule)
    WindowClass: TClassValue;
    CreateProc: TLangProc;
    CaptionProc: TLangProc;
    ShowFormProc: TLangProc;
    WriteProc: TLangProc;
    HeightProc: TLangProc;
    WidthProc: TLangProc;
    ColorProc: TLangProc;
    ClearProc: TLangProc;
    HideProc: TLangProc;
    procedure CreateProcExec(Sender: TVisualValue; S: IValStack;
      MustReturn: Boolean);
    procedure ShowProcExec(Sender: TVisualValue; S: IValStack;
      MustReturn: Boolean);
    procedure CaptionProcExec(Sender: TVisualValue; S: IValStack;
      MustReturn: Boolean);
    procedure ShowFormProcExec(Sender: TVisualValue; S: IValStack;
      MustReturn: Boolean);
    procedure WriteProcExec(Sender: TVisualValue; S: IValStack;
      MustReturn: Boolean);
    procedure HeightProcExec(Sender: TVisualValue; S: IValStack;
      MustReturn: Boolean);
    procedure WidthProcExec(Sender: TVisualValue; S: IValStack;
      MustReturn: Boolean);
    procedure ColorProcExec(Sender: TVisualValue; S: IValStack;
      MustReturn: Boolean);
    procedure ClearProcExec(Sender: TVisualValue; S: IValStack;
      MustReturn: Boolean);
    procedure HideProcExec(Sender: TVisualValue; S: IValStack;
      MustReturn: Boolean);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  WindowData: TWindowData;

implementation

{$R *.DFM}

procedure TWindowData.CreateProcExec(Sender: TVisualValue; S: IValStack;
  MustReturn: Boolean);
begin
  SetObjectOf(Sender,TWindow.Create(nil));
  S.DropFrame;
  ReturnTrue(S,MustReturn);

end;

procedure TWindowData.ShowProcExec(Sender: TVisualValue; S: IValStack;
  MustReturn: Boolean);
 Var I:Integer;
              str:string;
              Res:TVarLangValue;
          begin
            str:='';
            for i:=0 to S.FrameCount-1 do
            begin
              str:=str+s.FrameValues[i].AsString;
            end;
            S.DropFrame;
            if MustReturn then
            begin
              Res:=TVarLangValue.Create(nil);
              Res.AsBoolean:=true;
              S.Push(Res);
            end;
            MessageDlg(str,mtInformation,[mbOk],0);
       // Show a message: example: Show('This is a test');
          end;

procedure TWindowData.CaptionProcExec(Sender: TVisualValue; S: IValStack;
  MustReturn: Boolean);
 Var I:Integer;
              str:string;
              Res:TVarLangValue;
          begin
            str:='';
            for i:=0 to S.FrameCount-1 do
            begin
              str:=str+s.FrameValues[i].AsString;
            end;
            if s.FrameCount<>0 then
            (GetObjectOf(Sender) as TWindow).Caption:= str;
            // The form caption changes: Example: Caption('The CAMEL language v0.00c');
            S.DropFrame;
            if MustReturn then
            begin
              Res:=TVarLangValue.Create(nil);
              Res.AsString:= str;
              S.Push(Res);
            end;
          end;


procedure TWindowData.ShowFormProcExec(Sender: TVisualValue; S: IValStack;
  MustReturn: Boolean);
begin
(GetObjectOf(Sender) as TWindow).ShowModal;
S.DropFrame;
ReturnTrue(S,MustReturn);
end;

procedure TWindowData.WriteProcExec(Sender: TVisualValue; S: IValStack;
  MustReturn: Boolean);
Var I:Integer;
              str:string;
              Res:TVarLangValue;
          begin
            str:='';
            for i:=0 to S.FrameCount-1 do
            begin
              str:=str+s.FrameValues[i].AsString;
            end;
            if s.FrameCount<>0 then
             begin
             (GetObjectOf(Sender) as TWindow).Console.WriteString(str);
              // Write a string on the console Example: Write('The console is not clear now!';
             end;

            S.DropFrame;
            if MustReturn then
            begin
              Res:=TVarLangValue.Create(nil);
              Res.AsString:= str;
              S.Push(Res);
            end;
          end;

procedure TWindowData.HeightProcExec(Sender: TVisualValue; S: IValStack;
  MustReturn: Boolean);
 Var I:Integer;
              int:integer;
              Res:TVarLangValue;
          begin
            int:= 0;
            for i:=0 to S.FrameCount-1 do
            begin
              int:=int+s.FrameValues[i].AsInteger;
            end;
            if s.FrameCount<>0 then
            (GetObjectOf(Sender) as TWindow).Height:= int;
            // The form height changes: Example: Height(500);
            S.DropFrame;
            if MustReturn then
            begin
              Res:=TVarLangValue.Create(nil);
              Res.AsInteger:= int;
              S.Push(Res);
            end;
          end;

procedure TWindowData.WidthProcExec(Sender: TVisualValue; S: IValStack;
  MustReturn: Boolean);
 Var I:Integer;
              int:integer;
              Res:TVarLangValue;
          begin
            int:= 0;
            for i:=0 to S.FrameCount-1 do
            begin
              int:=int+s.FrameValues[i].AsInteger;
            end;
            if s.FrameCount<>0 then
            (GetObjectOf(Sender) as TWindow).Width:= int;
            // The form width changes: Example: Width(300);
            S.DropFrame;
            if MustReturn then
            begin
              Res:=TVarLangValue.Create(nil);
              Res.AsInteger:= int;
              S.Push(Res);
            end;
          end;

procedure TWindowData.ColorProcExec(Sender: TVisualValue; S: IValStack;
  MustReturn: Boolean);
Var I:Integer;
              Color: TColor;
              sColor: String;
              Res:TVarLangValue;
          begin
            sColor:='';
            for i:=0 to S.FrameCount-1 do
            begin
              sColor:=s.FrameValues[i].asString;
            end;
   if sColor = 'White' then Color:= clWhite
   else if sColor = 'Black' then Color:= clBlack
   else if sColor = 'Blue' then Color:= clBlue
   else if sColor = 'Green' then Color:= clGreen
   else if sColor = 'Red' then Color:= clRed
   else if sColor = 'Yellow' then Color:= clYellow
   else if sColor = 'Aqua' then Color:= clAqua
   else if sColor = 'Fuchsia' then Color:= clFuchsia;
            if s.FrameCount<>0 then
            (GetObjectOf(Sender) as TWindow).Console.Font.BkColor:= Color;

            // The Console background color changes: Example: Color(ClBlue);
            S.DropFrame;
            if MustReturn then
            begin
              Res:=TVarLangValue.Create(nil);
              Res.AsString:= sColor;
              S.Push(Res);
            end;
          end;

procedure TWindowData.ClearProcExec(Sender: TVisualValue; S: IValStack;
  MustReturn: Boolean);
begin
(GetObjectOf(Sender) as TWindow).Console.ClrScr;
S.DropFrame;
ReturnTrue(S,MustReturn);
end;

procedure TWindowData.HideProcExec(Sender: TVisualValue; S: IValStack;
  MustReturn: Boolean);
begin
(GetObjectOf(Sender) as TWindow).Console.Hide;
S.DropFrame;
ReturnTrue(S,MustReturn);
end;

end.
